using System.Text.Json.Serialization;
using JacobTechEncryption.Enums;
using Microsoft.AspNetCore.Mvc.ModelBinding;

namespace LuskiServer.Classes.v1.Incoming;

public class ClientSendMessage
{
    [JsonInclude]
    [BindRequired]
    [JsonRequired]
    [JsonPropertyName("channel_id")]
    public long ChannelID { get; set; }
    [JsonInclude]
    [BindRequired]
    [JsonRequired]
    [JsonPropertyName("context")]
    public string Base64Context { get; set; }
    
    [JsonInclude]
    [BindRequired]
    [JsonRequired]
    [JsonPropertyName("files")]
    public long[] Files { get; set; }
    [JsonInclude]
    [BindRequired]
    [JsonRequired]
    [JsonPropertyName("encryption")]
    public EncryptionType Encryption { get; set; }
    [JsonInclude]
    [BindRequired]
    [JsonRequired]
    [JsonPropertyName("encoding")]
    public EncoderType Encoding { get; set; }
}